subroutine param_off2ang3d(off2ang3d_par)
  use off2ang3d_types
  use sep

  implicit none
  type (off2ang3d_param_type) off2ang3d_par

  integer ::  omp_get_num_threads
  integer, external :: auxpar,getch,fetch,auxin,auxinout,sreed,sseek,auxout

  character(len=128) :: tag_name
  integer n_threads_env,n_threads_init
  integer n,n_ang,esize
  real d,o,ang_min,ang_max

  n_threads_init=1

  call from_param('verb',off2ang3d_par%verb,.false.)
  call from_param('debug1',off2ang3d_par%debug1,.false.)
  call from_param('debug2',off2ang3d_par%debug2,.false.)

  call from_param('create_coplanar_stack',off2ang3d_par%create_coplanar_stack,.false.)
  call from_param('create_coplanar_azim_ang',off2ang3d_par%create_coplanar_azim_ang,.false.)
  call from_param('create_coplanar_ang',off2ang3d_par%create_coplanar_ang,.false.)
  call from_param('create_stack',off2ang3d_par%create_stack,.false.)

  call from_param('n_threads',off2ang3d_par%n_threads,n_threads_init)
  call from_param('max_memory',off2ang3d_par%max_memory,100)


  ! checking parameters
!$omp parallel
  n_threads_env=omp_get_num_threads()
!$omp end parallel
  if(off2ang3d_par%n_threads == n_threads_init) then
     off2ang3d_par%n_threads=n_threads_env
  else
     if(n_threads_env > off2ang3d_par%n_threads) then
        call omp_set_num_threads(off2ang3d_par%n_threads)
        write(0,*)'WARNING: overwriting environment variable'
        write(0,*)'off2ang3d_par-n_threads=',off2ang3d_par%n_threads
     end if
     if(n_threads_env < off2ang3d_par%n_threads) then
        write(0,*)'off2ang3d_par-n_threads=',off2ang3d_par%n_threads
        write(0,*)'OMP_NUM_THREADS=',n_threads_env
        call seperr('ERROR: Asked for more threads than the environment variable allows')
     end if
  end if

  call from_param('apply_jac_gamma',off2ang3d_par%apply_jac_gamma,.false.)
  call from_param('apply_jac_azim_1',off2ang3d_par%apply_jac_azim_1,.false.)
  call from_param('apply_jac_azim_2',off2ang3d_par%apply_jac_azim_2,.false.)
  call from_param('jac_nowrap',off2ang3d_par%jac_nowrap,.false.)

  if(off2ang3d_par%debug1)write(0,*)'off2ang3d_par-n_threads=',off2ang3d_par%n_threads
  call to_history('n_threads',off2ang3d_par%n_threads)

    call from_param('number_aliases',off2ang3d_par%number_aliases,0)
    call from_param('sign_khy',off2ang3d_par%sign_khy,1.)

    call from_history('esize',off2ang3d_par%esize)
    if(off2ang3d_par%esize /= 8) call seperr("Input should be complex")

    call from_history('n1',off2ang3d_par%n_hx)
    call from_history('n2',off2ang3d_par%n_hy)
    call from_history('n3',off2ang3d_par%n_kz)
    call from_history('n4',off2ang3d_par%n_kmx)
    call from_history('n5',off2ang3d_par%n_kmy)
    
    call from_history('d1',off2ang3d_par%d_hx)
    call from_history('d2',off2ang3d_par%d_hy)
    call from_history('d3',off2ang3d_par%d_kz)
    call from_history('d4',off2ang3d_par%d_kmx)
    call from_history('d5',off2ang3d_par%d_kmy)
    
    call from_history('o1',off2ang3d_par%hx_0)
    call from_history('o2',off2ang3d_par%hy_0)
    call from_history('o3',off2ang3d_par%z_0)
    call from_history('o4',off2ang3d_par%mx_0)
    call from_history('o5',off2ang3d_par%my_0)

! check on parameters

    call to_history("From Input: esize",off2ang3d_par%esize)
    call to_history("From Input: n1",off2ang3d_par%n_hx)
    call to_history("From Input: n2",off2ang3d_par%n_hy)
    call to_history("From Input: n3",off2ang3d_par%n_kz)
    call to_history("From Input: n4",off2ang3d_par%n_kmx)
    call to_history("From Input: n5",off2ang3d_par%n_kmy)

    call to_history("From Input: d1",off2ang3d_par%d_hx)
    call to_history("From Input: d2",off2ang3d_par%d_hy)
    call to_history("From Input: d3",off2ang3d_par%d_kz)
    call to_history("From Input: d4",off2ang3d_par%d_kmx)
    call to_history("From Input: d5",off2ang3d_par%d_kmy)

    call to_history("From Input: o1",off2ang3d_par%hx_0)
    call to_history("From Input: o2",off2ang3d_par%hy_0)

    call from_param('n_hx_pad',off2ang3d_par%n_hx_pad,off2ang3d_par%n_hx)
    call from_param('n_hy_pad',off2ang3d_par%n_hy_pad,off2ang3d_par%n_hy)

    call from_param('n_azim',off2ang3d_par%n_azim,1)
    call from_param('d_azim',off2ang3d_par%d_azim,1.)
    call from_param('azim_0',off2ang3d_par%azim_0,0.)

    call from_param('azim_gamma_0',off2ang3d_par%azim_gamma_0,0.)
    call from_param('azim_min_gamma_max',off2ang3d_par%azim_min_gamma_max,0.)
    call from_param('azim_max_gamma_max',off2ang3d_par%azim_max_gamma_max,0.)
    call from_param('sin_pow',off2ang3d_par%sin_pow,2)

  if ((off2ang3d_par%create_coplanar_stack).or. &
      (off2ang3d_par%create_stack)) then
  !{
    call from_param('tag_coplanar_stack',off2ang3d_par%tag_coplanar_stack,'Coplanar_stack')
  
    off2ang3d_par%n_gamma=1

    call to_history("esize",off2ang3d_par%esize,trim(off2ang3d_par%tag_coplanar_stack))

    call to_history("n1",off2ang3d_par%n_azim,trim(off2ang3d_par%tag_coplanar_stack))
    call to_history("n2",off2ang3d_par%n_kz,trim(off2ang3d_par%tag_coplanar_stack))
    call to_history("n3",off2ang3d_par%n_kmx,trim(off2ang3d_par%tag_coplanar_stack))
    call to_history("n4",off2ang3d_par%n_kmy,trim(off2ang3d_par%tag_coplanar_stack))
  
    call to_history("d1",off2ang3d_par%d_azim,trim(off2ang3d_par%tag_coplanar_stack))
    call to_history("d2",off2ang3d_par%d_kz,trim(off2ang3d_par%tag_coplanar_stack))
    call to_history("d3",off2ang3d_par%d_kmx,trim(off2ang3d_par%tag_coplanar_stack))
    call to_history("d4",off2ang3d_par%d_kmy,trim(off2ang3d_par%tag_coplanar_stack))
  
    call to_history("o1",off2ang3d_par%azim_0,trim(off2ang3d_par%tag_coplanar_stack))
    call to_history("o2",off2ang3d_par%z_0,trim(off2ang3d_par%tag_coplanar_stack))
    call to_history("o3",off2ang3d_par%mx_0,trim(off2ang3d_par%tag_coplanar_stack))
    call to_history("o4",off2ang3d_par%my_0,trim(off2ang3d_par%tag_coplanar_stack))

  !}
  end if

  if (off2ang3d_par%create_coplanar_ang) then

    call from_param('tag_coplanar_ang',off2ang3d_par%tag_coplanar_ang,'Coplanar_ang')

    call from_param('n_gamma',off2ang3d_par%n_gamma,1)
    call from_param('d_gamma',off2ang3d_par%d_gamma,1.)
    call from_param('gamma_0',off2ang3d_par%gamma_0,0.)

    if(off2ang3d_par%azim_gamma_0 /= 0.) then
      if(mod(off2ang3d_par%azim_gamma_0,off2ang3d_par%d_azim) /= 0.) then
        call seperr ('azim_gamma_0 not multiple of d_azim')
      end if

      off2ang3d_par%n_azim_max=(2*off2ang3d_par%azim_gamma_0/off2ang3d_par%d_azim)+1
      off2ang3d_par%azim_0_max=-off2ang3d_par%azim_gamma_0
    else
      off2ang3d_par%n_azim_max=off2ang3d_par%n_azim
      off2ang3d_par%azim_0_max=off2ang3d_par%azim_0

    end if

    call to_history("esize",off2ang3d_par%esize,trim(off2ang3d_par%tag_coplanar_ang))

    call to_history("n1",off2ang3d_par%n_gamma,trim(off2ang3d_par%tag_coplanar_ang))
    call to_history("n2",off2ang3d_par%n_kz,trim(off2ang3d_par%tag_coplanar_ang))
    call to_history("n3",off2ang3d_par%n_kmx,trim(off2ang3d_par%tag_coplanar_ang))
    call to_history("n4",off2ang3d_par%n_kmy,trim(off2ang3d_par%tag_coplanar_ang))
  
    call to_history("d1",off2ang3d_par%d_gamma,trim(off2ang3d_par%tag_coplanar_ang))
    call to_history("d2",off2ang3d_par%d_kz,trim(off2ang3d_par%tag_coplanar_ang))
    call to_history("d3",off2ang3d_par%d_kmx,trim(off2ang3d_par%tag_coplanar_ang))
    call to_history("d4",off2ang3d_par%d_kmy,trim(off2ang3d_par%tag_coplanar_ang))
  
    call to_history("o1",off2ang3d_par%gamma_0,trim(off2ang3d_par%tag_coplanar_ang))
    call to_history("o2",off2ang3d_par%z_0,trim(off2ang3d_par%tag_coplanar_ang))
    call to_history("o3",off2ang3d_par%mx_0,trim(off2ang3d_par%tag_coplanar_ang))
    call to_history("o4",off2ang3d_par%my_0,trim(off2ang3d_par%tag_coplanar_ang))

  !}
  end if



  if (off2ang3d_par%create_coplanar_azim_ang) then
  !{

    call from_param('tag_coplanar_azim_ang',off2ang3d_par%tag_coplanar_azim_ang,'Coplanar_azim_ang')

    call from_param('ang_2d',off2ang3d_par%ang_2d,.false.)

    call from_param('n_gamma',off2ang3d_par%n_gamma,1)
    call from_param('d_gamma',off2ang3d_par%d_gamma,1.)
    call from_param('gamma_0',off2ang3d_par%gamma_0,0.)

    if(off2ang3d_par%azim_gamma_0 /= 0.) then
      if(mod(off2ang3d_par%azim_gamma_0,off2ang3d_par%d_azim) /= 0.) then
        call seperr ('azim_gamma_0 not multiple of d_azim')
      end if

      off2ang3d_par%n_azim_max=(2*off2ang3d_par%azim_gamma_0/off2ang3d_par%d_azim)+1
      off2ang3d_par%azim_0_max=-off2ang3d_par%azim_gamma_0
    else
      off2ang3d_par%n_azim_max=off2ang3d_par%n_azim
      off2ang3d_par%azim_0_max=off2ang3d_par%azim_0
write(0,*)'azim_0_par=',off2ang3d_par%azim_0
    end if

    if(off2ang3d_par%azim_min_gamma_max /= 0.) then
      if(mod(off2ang3d_par%azim_min_gamma_max,off2ang3d_par%d_azim) /= 0.) then
        call seperr ('azim_min_gamma_max not multiple of d_azim')
      end if
    end if
    if(off2ang3d_par%azim_max_gamma_max /= 0.) then
      if(mod(off2ang3d_par%azim_max_gamma_max,off2ang3d_par%d_azim) /= 0.) then
        call seperr ('azim_max_gamma_max not multiple of d_azim')
      end if
    end if
    

    call to_history("esize",off2ang3d_par%esize,trim(off2ang3d_par%tag_coplanar_azim_ang))

    call to_history("n1",off2ang3d_par%n_gamma,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("n2",off2ang3d_par%n_azim_max,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("n3",off2ang3d_par%n_kz,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("n4",off2ang3d_par%n_kmx,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("n5",off2ang3d_par%n_kmy,trim(off2ang3d_par%tag_coplanar_azim_ang))
  
    call to_history("d1",off2ang3d_par%d_gamma,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("d2",off2ang3d_par%d_azim,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("d3",off2ang3d_par%d_kz,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("d4",off2ang3d_par%d_kmx,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("d5",off2ang3d_par%d_kmy,trim(off2ang3d_par%tag_coplanar_azim_ang))
  
    call to_history("o1",off2ang3d_par%gamma_0,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("o2",off2ang3d_par%azim_0_max,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("o3",off2ang3d_par%z_0,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("o4",off2ang3d_par%mx_0,trim(off2ang3d_par%tag_coplanar_azim_ang))
    call to_history("o5",off2ang3d_par%my_0,trim(off2ang3d_par%tag_coplanar_azim_ang))


  !}
  end if
  
  return

end subroutine param_off2ang3d
